#ifndef _FRAMESRC_ABSTRACT_H
#define _FRAMESRC_ABSTRACT_H

class frames_source
{
public:
    frames_source(char* filename);
    virtual ~frames_source();
    
    // returns 1 if file is loaded.
    virtual int ready();
    
    // return frames count
    virtual int frames();
    
    // load frame into given framebuffer
    virtual int load(void* buffer, int frame_number) = 0;

    // return class name
    virtual char* whoami() = 0;

protected:
    void* _file_handler;
    char* _file_name;
    int _operation_ready;
    int _frames_count;
};

frames_source* open_frame_source(char* id);
extern char frames_source_path[1024];

#endif	// _FRAMESRC_ABSTRACT_H
