#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "frames_source.h"
#include "frames_source_raw.h"

#define CLEAR(x) memset (&(x), 0, sizeof (x))

#define FOURCC_DVSD FOURCC_DIRECT('d','v','s','d')

frames_source_raw::frames_source_raw(char* filename) : frames_source(filename)
{
    _fb = malloc(144000);
    _current_frame = 0xFFFFFFFF;;

    // determinate how much frames we have
    if(_file_handler != NULL)
    {
	// seek to end
	fseek((FILE*)_file_handler,0L,SEEK_END);
	
	// get position
	long size = ftell((FILE*)_file_handler);
	
	// seek to begin
	fseek((FILE*)_file_handler,0L,SEEK_END);
	
	// calculate frames count
	_frames_count = size / 144000 ;
    };

};


frames_source_raw::~frames_source_raw()
{
    if(_fb)
	free(_fb);
};

char* frames_source_raw::whoami()
{
    return "frames_source_raw";
};


int frames_source_raw::load(void* buffer, int frame_number)
{
    // first check if given number in range
    if( (frame_number >= 0) && (_frames_count > 0) && (frame_number < _frames_count) )
    {
	// check if current frame is equal to given
	if(_current_frame != frame_number)
	{
	    // position to proper
	    fseek((FILE*)_file_handler, 144000L * (long)frame_number, SEEK_SET);
	    
	    // load buffer
	    if (144000L == fread(_fb, 1, 144000L, (FILE*)_file_handler))
	    {
		memcpy(buffer,_fb,144000L);
		_current_frame = frame_number;
		return 1;
	    };
	}
	else
	{
	    memcpy(buffer,_fb,144000L);
	    _current_frame = frame_number;
	    return 1;
	};
	
    };
    
    return 0;
};

